package org.zeroturnaround.javarebel.integration.servlet;

import org.zeroturnaround.javarebel.ClassResourceSource;
import org.zeroturnaround.javarebel.IntegrationFactory;
import org.zeroturnaround.javarebel.Plugin;
import org.zeroturnaround.javarebel.integration.generic.BaseServletContextImplClassBytecodeProcessor;
import org.zeroturnaround.javarebel.integration.generic.ServletContextImplClassBytecodeProcessor;
import org.zeroturnaround.javarebel.integration.servlet.cbp.JettyServletHandlerClassBytecodeProcessor;
import org.zeroturnaround.javarebel.integration.servlet.cbp.ServletContextClassBytecodeProcessor;

/**
 * @author Rein Raudjärv
 */
public class ServletIntegrationPlugin implements Plugin {
  public void preinit() {
    ClassLoader cl = getClass().getClassLoader();
    
    // ServletContext
    IntegrationFactory.getInstance().addIntegrationProcessor(
        cl,
        "javax.servlet.ServletContext", 
        new ServletContextClassBytecodeProcessor());

    // JETTY 5
    IntegrationFactory.getInstance().addIntegrationProcessor(
        "org.mortbay.jetty.servlet.ServletHandler$Context", 
        new BaseServletContextImplClassBytecodeProcessor());
    IntegrationFactory.getInstance().addIntegrationProcessor(
        "org.mortbay.jetty.servlet.ServletHandler", 
        new JettyServletHandlerClassBytecodeProcessor());

    // TOMCAT 5.5
    IntegrationFactory.getInstance().addIntegrationProcessor(
        "org.apache.catalina.core.ApplicationContext", 
        new ServletContextImplClassBytecodeProcessor());

    // WEBLOGIC 9.2
    IntegrationFactory.getInstance().addIntegrationProcessor(
        "weblogic.servlet.internal.WebAppServletContext", 
        new ServletContextImplClassBytecodeProcessor());
  }
  
  public boolean checkDependencies(ClassLoader cl, ClassResourceSource crs) {
    return crs.getClassResource("javax.servlet.ServletContext") != null;
  }
}
